/* c01/ejemplo-02.c
Inicializacin de subsistemas en SDL
*/
#include <SDL/SDL.h>

int main(void){
    SDL_Surface *pantalla = NULL;
    
    //Estos son los diversos subsistemas:
    //SDL_INIT_TIMER
    //SDL_INIT_AUDIO
    //SDL_INIT_VIDEO
    //SDL_INIT_CDROM
    //SDL_INIT_JOYSTICK
    //SDL_INIT_EVERYTHING
    if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_CDROM | SDL_INIT_AUDIO) < 0){
        printf("Error al iniciar SDL con los subsitemas de video, de unidad ptica y de sonido: %s\n", SDL_GetError());
        exit(1);
    }
    atexit(SDL_Quit);
    
    //inicializar el subsistema de palanca de mandos:
    SDL_InitSubSystem(SDL_INIT_JOYSTICK);
    
    //apaga los subsistemas de video y de audio
    SDL_QuitSubSystem(SDL_INIT_VIDEO | SDL_INIT_CDROM);
    
    if(SDL_WasInit(SDL_INIT_VIDEO))
        printf("El video est encendido\n");
    else
        printf("El video est apagado\n");
    
    if(SDL_WasInit(SDL_INIT_CDROM))
        printf("El cdrom est encendido\n");
    else
        printf("El cdrom est apagado\n");
    
    if(SDL_WasInit(SDL_INIT_AUDIO))
        printf("El audio est encendido\n");
    else
        printf("El audio est apagado\n");
    
    if(SDL_WasInit(SDL_INIT_JOYSTICK))
        printf("El joystick est encendido\n");
    else
        printf("El joystick est apagado\n");
    
    //apaga todos los subsistemas de SDL
    SDL_Quit();
    return 0;
}
