/* c01/ejemplo-06.c
 * Redimensionamiento en SDL
*/
#include <SDL/SDL.h>
#define PROFUNDIDAD_COLOR 16

int main(void){
    SDL_Surface *pantalla = NULL;
    SDL_Event evento;
    int ANCHO = 400, ALTO = 400;
    int corriendo = 1;
    
    if (SDL_Init(SDL_INIT_VIDEO) < 0){
        printf("Error al iniciar SDL: %s\n", SDL_GetError());
        exit(1);
    }
    atexit(SDL_Quit);
    
    pantalla = SDL_SetVideoMode(ANCHO, ALTO, PROFUNDIDAD_COLOR,  SDL_SWSURFACE|SDL_RESIZABLE);
    if (pantalla == NULL){
        printf("Error al inicializar el modo de video: '%s'\n", SDL_GetError());
        exit(1);
    }    
    
    SDL_WM_SetCaption("Prueba de redimensionamiento", NULL);
    
    while(corriendo) {

        while(SDL_PollEvent(&evento)) {
            switch(evento.type){
                /*
                    Consultar el archivo:
                    /usr/include/SDL/SDL_events.h
                    All se encuentra la definicin de la unin 'SDL_Event'.
                */
                case SDL_VIDEORESIZE:
                    //redimensionar la pantalla, no hace falta liberar la anterior.
                    pantalla = SDL_SetVideoMode(evento.resize.w, evento.resize.h, PROFUNDIDAD_COLOR, SDL_SWSURFACE|SDL_RESIZABLE);
                    if(pantalla == NULL){
                        printf("Error al redimensionar la pantalla: '%s'\n", SDL_GetError());
                        exit(1);
                    }
                    printf("La ventana se ha redimensionado de %dx%d pixeles a %dx%d\n",
                        ANCHO, ALTO, evento.resize.w, evento.resize.h);
                    ANCHO = evento.resize.w;
                    ALTO = evento.resize.h;
                    //Aqu habra que redibujar lo que se estaba mostrando
                    //ya que 'pantalla' aparece borrada
                    break;
                
                case SDL_QUIT:
                    corriendo = 0;
                    break;
            }
        }
    }
    
    SDL_Quit();
    return 0;
}
