/* c01/ejemplo-07/primitivas.c
 * */
#include "primitivas_.h"

void dibujar_rectangulo(SDL_Surface *s, SDL_Rect rectangulo, Uint32 color){
    int i;
    for(i=rectangulo.x; i<rectangulo.x+rectangulo.w; i++){
        ponerPixel(s, i, rectangulo.y,              color);
        ponerPixel(s, i, rectangulo.y+rectangulo.h-1, color);
    }
    for(i=rectangulo.y; i<rectangulo.y+rectangulo.h; i++){
        ponerPixel(s, rectangulo.x,              i, color);
        ponerPixel(s, rectangulo.x+rectangulo.w-1, i, color);
    }
}

void ponerPixel(SDL_Surface *surface, int x, int y, Uint32 pixel){
    int bpp = surface->format->BytesPerPixel;
    // Aqu p es la direccin del pixel que queremos encender
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;
    
    if((x>surface->w)||(y>surface->h)||(x<0)||(y<0)) return;
    
    switch(bpp) {
    case 1:
        *p = pixel;
        break;
    
    case 2:
        *(Uint16 *)p = pixel;
        break;
    
    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
            p[0] = (pixel >> 16) & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = pixel & 0xff;
        }
        else {
            p[0] = pixel & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = (pixel >> 16) & 0xff;
        }
        break;
    
    case 4:
        *(Uint32 *)p = pixel;
        break;
    }
}
