/* c04/campos vectoriales/campo.c
 * */
#include <math.h>
#include "campo_.h"

void campoElectrico(CargaElectrica *carga, Vector *punto, Vector* campo){
    Vector distancia;
    double magnitudDistancia3;
    distancia.x = punto->x - carga->posicion.x;
    distancia.y = punto->y - carga->posicion.y;
    magnitudDistancia3 = pow(magnitudVector(&distancia),3.0);
    campo->x = _1_4PIe0 * carga->valor * distancia.x / magnitudDistancia3;
    campo->y = _1_4PIe0 * carga->valor * distancia.y / magnitudDistancia3;
}

void campoElectricoCargas(CargaElectrica *cargas, int cantidad, Vector *punto, Vector* campo){
    int k;
    Vector temp;
    campo->x = campo->y = 0.0;
    for(k=0;k<cantidad;k++){
        campoElectrico(cargas+k, punto, &temp);
        campo->x += temp.x;
        campo->y += temp.y;
    }
}

double magnitudVector(Vector *v){
    return sqrt(v->x*v->x + v->y*v->y);
}
