/* c04/campos vectoriales/escala.c
 * */
#include "escala_.h"

int tR_Vx(double xV, Escala *e){
    return (int) ((xV - e->XminV) * e->AnchoR / (e->XmaxV - e->XminV));
}

int tR_Vy(double yV, Escala *e){
    return (int) ((yV - e->YmaxV) * -e->AltoR / (e->YmaxV - e->YminV));
}

double tV_Rx(int xR, Escala *e){
    return e->XminV + xR * (e->XmaxV-e->XminV)/e->AnchoR;
}

double tV_Ry(int yR, Escala *e){
    return e->YmaxV - (e->YmaxV-e->YminV)*yR/e->AltoR;
}

int mR_Vx(double deltaxV, Escala *e){
    return deltaxV*e->AnchoR/(e->XmaxV-e->XminV);
}

int mR_Vy(double deltayV, Escala *e){
    return deltayV * -e->AltoR/(e->YmaxV-e->YminV);
}

double mV_Rx(int deltaxR, Escala *e){
    return deltaxR*(e->XmaxV-e->XminV)/e->AnchoR;
}

double mV_Ry(int deltayR, Escala *e){
    return deltayR*(e->YmaxV-e->YminV) / -e->AltoR;
}

void imprimirEscala(FILE *salida, Escala *e){
    fprintf(salida, "Datos de escala:\n");
    fprintf(salida, "AnchoR:\t%d\nAltoR:\t%d\n", e->AnchoR, e->AltoR);
    fprintf(salida, "[%f,%f]-[%f,%f]\n", e->XminV, e->YminV, e->XmaxV, e->YmaxV);
}

