/* c04/campos vectoriales/escala_.h
 * Esta es una versin particular del problema
 * de la transformacin de escalas.
 * No es una solucin general para cualquier caso.
 * */
#include <stdio.h>

/*
 * Estructura para manipular escala
 * de pantalla completa
 * */
typedef struct {
    int AnchoR, AltoR;
    double XminV, YminV;
    double XmaxV, YmaxV;
} Escala;

/*
 * Funciones de transformacin vectorial
 * entre el marco de referencia Real y el Virtual
 * 
 * La primera funcin se lee:
 * "Transformacin a Real, dado el Virtual en x"
 * */
int tR_Vx(double xV, Escala *e);
int tR_Vy(double yV, Escala *e);
double tV_Rx(int xR, Escala *e);
double tV_Ry(int yR, Escala *e);

/*
 * Funciones de tranformacin de distancias
 * entre el marco de referencia Real y el Virtual
 * 
 * La primera funcin se lee:
 * "Magnitud en Real, dado el Virtual en x"
 * */
int mR_Vx(double deltaxV, Escala *e);
int mR_Vy(double deltayV, Escala *e);
double mV_Rx(int deltaxR, Escala *e);
double mV_Ry(int deltayR, Escala *e);

void imprimirEscala(FILE *salida, Escala *e);
