/* c06/transformaciones3d/Punto3d.java
 * Representa un punto en el espacio tridimensional
 */
public class Punto3d {
    float x = 0f;  // Coordenadas 3-d
    float y = 0f;
    float z = 0f;

    public Punto3d(float x0, float y0, float z0){
        x = x0;
        y = y0;
        z = z0;
    }
    
    /*
     * Retorna el producto punto entre este punto
     * y el punto proporcionado como parmetro
     */
    public float punto(Punto3d p){
        return x*p.x + y*p.y + z*p.z;
    }
    
    /*
     * Retorna el producto cruz entre este punto
     * y el punto proporcionado como parmetro
     */
    public Punto3d cruz(Punto3d p){
        return new Punto3d(
            y*p.z - p.y*z,
            p.x*z - x*p.z,
            x*p.y - y*p.x
        );
    }
    
    /*
     * Retorna el vector que va del extremo del punto
     * proporcionado como parmetro, al extremo de este punto
     */
    public Punto3d resta(Punto3d otro){
        return new Punto3d(x-otro.x, y-otro.y, z-otro.z);
    }
    
    /*
     * Calcula la magnitud de este punto
     */
    public float magnitud(){
        return (float)Math.sqrt(x*x+y*y+z*z);
    }
    
    public String toString(){
         return(new String("(" + x + "," + y + "," + z + ")"));
    }
}
