/* c07/transformaciones3d/Config3D.java
 * Archivo de configuraciones de la aplicacin
*/
import java.awt.*;
/*
* Constantes Globales
*
*/
public interface Config3D{
    
    //+++++++++++++++++++++++++++++++++++++
    
    public static final int MODO_PROYECCION = 1 << 10;
    
    /*no hay percepcin de profundidad*/
    public static final int ORTOGONAL = (1 << 8) | MODO_PROYECCION;
    
    /*hay percepcin de profundidad y el observador debe
    estar suficientemente lejos como para que la imagen no se distorsione*/
    public static final int PERSPECTIVA = (1 << 9) | MODO_PROYECCION;
    
    //+++++++++++++++++++++++++++++++++++++
    
    public static final int OPERACION_TRASLACION = 1;
    public static final int OPERACION_ESCALAMIENTO = 2;
    public static final int OPERACION_ESCALAMIENTO_UNIFORME = 3;
    public static final int OPERACION_ROTACION_X = 4;
    public static final int OPERACION_ROTACION_Y = 5;
    public static final int OPERACION_ROTACION_Z = 6;
    
    //+++++++++++++++++++++++++++++++++++++
    
    Dimension tamanhoReal = new Dimension(400, 300);
    float anchoVirtual = 4f;
    float altoVirtual = 3f;
    
    //Dimensiones de los objetos
    final float LARGOEJES = 4f;
    final float ANCHOCUBO_2 = 2f;
    final float DISTANCIA_INICIAL = 3f;
    
    //para poder rotar con el mouse:
    int numPixelesparaMovimiento = 1;
    float factorRapidezGiro = 4f;
    
    //aumento del zoom por movimiento de la rueda del ratn:
    static final float MAGNITUD_AUMENTO = 0.5f;
    
    //de grados a radianes:
    static final double aRad = Math.PI/180.0;
    
    //parmetros para la consola
    String NOMBRE_CUBO = "cubo";
    String NOMBRE_PLANO = "plano";
    String NOMBRE_OJO = "ojo";
    String NOMBRE_TODOS = "todos";
    
    String NOMBRE_TRASLACION = "t";
    String NOMBRE_ESCALAMIENTO = "e";
    String NOMBRE_ESCALAMIENTO_UNIFORME = "eu";
    String NOMBRE_ROTACION_X = "rx";
    String NOMBRE_ROTACION_Y = "ry";
    String NOMBRE_ROTACION_Z = "rz";
    
    String NOMBRE_MOSTRAR = "mostrar";
    String NOMBRE_OCULTAR = "ocultar";
    
    String NOMBRE_SALIR = "salir";
    String NOMBRE_AYUDA = "ayuda";
    String NOMBRE_REINICIAR = "reiniciar";
    char INICIO_COMENTARIO = '%';
    
}
