/* c07/transformaciones3d/Controlador.java
 * Objeto controlador e intrprete de comandos grficos
*/
import java.awt.Graphics;
import java.awt.event.*;
import java.io.*;

/*
 * Controlador de la aplicacin
 */

/**
 *
 * @author  eduardo
 */
public class Controlador implements Config3D, Tildes {
    
    /**
     */
    public static void main(String args[]) {
        new Controlador(args);
    }
    
    Ventana vista;
    Universo3D modelo;
    
    private int x=0, y=0;
    private boolean cambio = false;
    private int xn, yn;
    private float Theta=45, Phi=45;
    
    /*
        Hilo principal
    */
    public Controlador (String args[]){
        vista = new Ventana(this);
        modelo = new Universo3D();
        vista.setVisible(true);
        System.out.println("Iniciando aplicaci" + otilde + "n");
        
        String cadena;
        String [] instrucciones;
        boolean salir = false;
        
        // Creacin de BufferedReader para facilitar la lectura.
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        int i;
        while(!salir){
            try{
                System.out.print(":");
                cadena = br.readLine();
                instrucciones = cadena.split("\\s");//separa por espacios
                
                if(instrucciones != null && instrucciones.length>0 && !instrucciones[0].equals("")){
                    if(instrucciones[0].charAt(0)==INICIO_COMENTARIO){
                        //es un comentario,
                        //se debe ignorar toda la linea
                    }
                    else if(instrucciones[0].equals(NOMBRE_SALIR)){
                        salir = true;
                        System.out.println("Saliendo de la aplicaci" + otilde + "n");
                    }
                    else if(instrucciones[0].equals(NOMBRE_AYUDA)){
                        ayuda();
                    }
                    else if(instrucciones[0].equals(NOMBRE_REINICIAR)){
                        modelo = new Universo3D();
                        Theta=45; Phi=45;
                        vista.setSize(tamanhoReal);
                        vista.repaint();
                    }
                    
                    else if(instrucciones.length==3 || instrucciones.length==5){
                        if(instrucciones[0].equals(NOMBRE_CUBO) || instrucciones[0].equals(NOMBRE_OJO) || instrucciones[0].equals(NOMBRE_PLANO) || instrucciones[0].equals(NOMBRE_TODOS)){
                            if(instrucciones[1].equals(NOMBRE_TRASLACION) || instrucciones[1].equals(NOMBRE_ESCALAMIENTO)){
                                //tres parmetros ms
                                modelo.configurar(
                                    ixObjeto(instrucciones[0]),
                                    ixOperacion(instrucciones[1]),
                                    new float[]{
                                        Float.parseFloat(instrucciones[2]),
                                        Float.parseFloat(instrucciones[3]),
                                        Float.parseFloat(instrucciones[4])
                                    });
                                modelo.cambiarDistancia(0f);
                                vista.repaint();
                            }
                            else if(instrucciones[1].equals(NOMBRE_ESCALAMIENTO_UNIFORME) || 
                            instrucciones[1].equals(NOMBRE_ROTACION_X) || instrucciones[1].equals(NOMBRE_ROTACION_Y) || instrucciones[1].equals(NOMBRE_ROTACION_Z)){
                                //un parmetro ms
                                modelo.configurar(
                                    ixObjeto(instrucciones[0]),
                                    ixOperacion(instrucciones[1]),
                                    new float[]{Float.parseFloat(instrucciones[2])});
                                modelo.cambiarDistancia(0f);
                                vista.repaint();
                            }
                            else entradaErronea(instrucciones);
                        }
                        else entradaErronea(instrucciones);
                    }
                    else if(instrucciones.length==2){
                        if(instrucciones[0].equals(NOMBRE_CUBO) || instrucciones[0].equals(NOMBRE_OJO) || instrucciones[0].equals(NOMBRE_PLANO) || instrucciones[0].equals(NOMBRE_TODOS)){
                            if(instrucciones[1].equals(NOMBRE_MOSTRAR) || instrucciones[1].equals(NOMBRE_OCULTAR)){
                                modelo.visibilidad(
                                    ixObjeto(instrucciones[0]),
                                    instrucciones[1].equals(NOMBRE_MOSTRAR)
                                );
                                modelo.cambiarDistancia(0f);
                                vista.repaint();
                            }
                            else entradaErronea(instrucciones);
                        }
                        else entradaErronea(instrucciones);
                    }
                    else if(instrucciones[0].equals("")){}
                    else entradaErronea(instrucciones);
                }
                else entradaErronea(instrucciones);
                
            }
            catch (IOException e){
                System.out.println("Error en la entrada est" + atilde + "ndar (tipo: " + e.getClass().getName() + ")\nMensaje enviado: " + e.getMessage());
            }
            catch (NumberFormatException e){
                System.out.println("Error en la entrada est" + atilde + "ndar (tipo: " + e.getClass().getName() + ")\nMensaje enviado: " + e.getMessage());
            }
            catch (Exception e){
                System.out.println("Error en la entrada est" + atilde + "ndar (tipo: " + e.getClass().getName() + ")\nMensaje enviado: " + e.getMessage());
            }
        }
        
        System.out.println();
        System.exit(0);

    }
    
    public void entradaErronea(String []parametros){
        System.out.println("Comando no identificado (escriba '" + NOMBRE_SALIR + "' para salir)");
        
        if(parametros!=null){
            System.out.println("Lista de par" + atilde + "metros que usted introdujo:");
            for(int i=0; i<parametros.length; i++)
                System.out.println(i + ": '" + parametros[i] + "'");
        }
        
        System.out.println();
        ayuda();
    }
    
    private void ayuda(){
        System.out.println("Sintaxis: ");
        
        System.out.println('>' + NOMBRE_AYUDA);
        System.out.println('>' + NOMBRE_REINICIAR);
        System.out.println(">" + INICIO_COMENTARIO + "comentarios...");
        System.out.print  ('>' + "{" + NOMBRE_CUBO + "|" + NOMBRE_PLANO + "|" + NOMBRE_OJO + "|" + NOMBRE_TODOS + "} ");
        System.out.println("{" + NOMBRE_MOSTRAR + "|" + NOMBRE_OCULTAR + "}");
        
        System.out.print  ('>' + "{" + NOMBRE_CUBO + "|" + NOMBRE_PLANO + "|" + NOMBRE_OJO + "|" + NOMBRE_TODOS + "} ");
        System.out.print  ("{" + NOMBRE_TRASLACION + "|" + 
            NOMBRE_ESCALAMIENTO + "|" + NOMBRE_ESCALAMIENTO_UNIFORME + "|" + 
            NOMBRE_ROTACION_X + "|" + NOMBRE_ROTACION_Y + "|" + NOMBRE_ROTACION_Z + "} ");
        System.out.println("<par" + atilde + "metros_de_la_transformaci" + otilde + "n>\n");
        
        System.out.println("Par" + atilde + "metros v" + atilde + "lidos: ");
        System.out.println(NOMBRE_TRASLACION + ": <dx> <dy> <dz>");
        System.out.println(NOMBRE_ESCALAMIENTO + ": <sx> <sy> <sz>");
        System.out.println(NOMBRE_ESCALAMIENTO_UNIFORME + ": <s>");
        System.out.println(NOMBRE_ROTACION_X + ": <theta>");
        System.out.println(NOMBRE_ROTACION_Y + ": <theta>");
        System.out.println(NOMBRE_ROTACION_Z + ": <theta>");
    }
    
    public void dibujar(Graphics g){
        modelo.dibujar(g);
    }
    
    
    public WindowAdapter AdaptadorVentana = new WindowAdapter() {
        public void windowClosing(java.awt.event.WindowEvent evt) {
            System.out.println();
            System.exit(0);
        }
    };
    
    public MouseWheelListener AdaptadorMouseWheel = new MouseWheelListener(){
        public void mouseWheelMoved(MouseWheelEvent e){
            if(e.getScrollType()==MouseWheelEvent.WHEEL_UNIT_SCROLL){
                modelo.cambiarDistancia(- MAGNITUD_AUMENTO * e.getWheelRotation());
                vista.repaint();
            }
        }
    };//	fin del objeto MouseWheelListener
    
    public MouseAdapter AdaptadorMouse = new MouseAdapter(){
        public void mousePressed(MouseEvent e){
            x = e.getX(); y = e.getY();
        }
        /*public void mouseClicked(MouseEvent e){
            //aqu se puede capturar el doble clic
        }*/
    };//	fin del objeto MouseAdapter
    
    public MouseMotionAdapter AdaptadorMouseMotion = new MouseMotionAdapter(){
        public void mouseDragged(MouseEvent e){
            xn = e.getX(); yn = e.getY();
            
            cambio = false;
            
            if(Math.abs(xn-x)>=numPixelesparaMovimiento){
                Theta -= (xn-x)/factorRapidezGiro;
                if(Theta < 0)
                    Theta = 359;
                else if(Theta > 359)
                    Theta = 0;
                
                x = xn;
                cambio = true;
            }
            if(Math.abs(yn-y)>=numPixelesparaMovimiento){
                Phi -= (yn-y)/factorRapidezGiro;
                if(Phi < 0)
                    Phi = 359;
                else if(Phi > 359)
                    Phi = 0;
                
                y = yn;
                cambio = true;
            }
            if(cambio){
                modelo.colocarPuntodeVision(Theta, Phi);
                vista.repaint();
            }
        }
    };//	fin del objeto MouseMotionAdapter
    
    public ComponentAdapter AdaptadorComponent = new ComponentAdapter(){
        public void componentResized(ComponentEvent e){
            if(modelo!=null)
                modelo.cambiarPortaldeVision(e.getComponent().getSize());
            vista.repaint();
        }
    };
    
    private int ixObjeto(String objeto){
        if(objeto.equals(NOMBRE_CUBO))
            return 1;
        else if(objeto.equals(NOMBRE_PLANO))
            return 2;
        else if(objeto.equals(NOMBRE_OJO))
            return 3;
        else if(objeto.equals(NOMBRE_TODOS))
            return 0;
        else
            return -1;
    }
    
    private int ixOperacion(String oper){
        if(oper.equals(NOMBRE_TRASLACION))
            return OPERACION_TRASLACION;
        else if(oper.equals(NOMBRE_ESCALAMIENTO))
            return OPERACION_ESCALAMIENTO;
        else if(oper.equals(NOMBRE_ESCALAMIENTO_UNIFORME))
            return OPERACION_ESCALAMIENTO_UNIFORME;
        else if(oper.equals(NOMBRE_ROTACION_X))
            return OPERACION_ROTACION_X;
        else if(oper.equals(NOMBRE_ROTACION_Y))
            return OPERACION_ROTACION_Y;
        else if(oper.equals(NOMBRE_ROTACION_Z))
            return OPERACION_ROTACION_Z;
        else
            return -1;
    }
    
}
//fin de la clase Controlador
