/* c07/transformaciones3d/Objeto3DSimple.java
 * Clases 3D bsicas
*/
public class Objeto3DSimple implements Config3D{
    VerticeSimple puntos[];
    AristaSimple aristas[];
    boolean visible = true;
    
    /*
     * Transformar todos los vrtices mediante una matriz
     * para ser proyectados en un portal de visin.
     * Toma como base, los puntos reales.
     * 
     * Tiene la alternativa de agregar perspectiva, pero asumiendo
     * que luego de la transformacin, el portal de visin quedar
     * paralelo al plano xy, y con su centro en (0,0,0) virtual.
     * */
    public void transformarProyeccion(Matriz3d m, PortaldeVision portal, boolean agregarPerspectiva){
        for(int i=0; i<puntos.length; i++){
            puntos[i].puntoProyectado.x = m.e[0][0] * puntos[i].puntoReal.x + m.e[0][1] * puntos[i].puntoReal.y + m.e[0][2] * puntos[i].puntoReal.z + m.e[0][3];
            puntos[i].puntoProyectado.y = m.e[1][0] * puntos[i].puntoReal.x + m.e[1][1] * puntos[i].puntoReal.y + m.e[1][2] * puntos[i].puntoReal.z + m.e[1][3];
            puntos[i].puntoProyectado.z = m.e[2][0] * puntos[i].puntoReal.x + m.e[2][1] * puntos[i].puntoReal.y + m.e[2][2] * puntos[i].puntoReal.z + m.e[2][3];
            
            if(agregarPerspectiva){
                puntos[i].puntoProyectado.x = portal.distanciaProyeccion*puntos[i].puntoProyectado.x/(puntos[i].puntoProyectado.z+portal.distanciaProyeccion);
                puntos[i].puntoProyectado.y = portal.distanciaProyeccion*puntos[i].puntoProyectado.y/(puntos[i].puntoProyectado.z+portal.distanciaProyeccion);
                puntos[i].puntoProyectado.z = 0;
            }
        }
    }
    
    /*
     * Transformar todos los vrtices mediante una matriz
     * para ser proyectados en un portal de visin.
     * Toma como base, los puntos ya proyectados
     * 
     * Tiene la alternativa de agregar perspectiva, pero asumiendo
     * que luego de la transformacin, el portal de visin quedar
     * paralelo al plano xy, y con su centro en (0,0,0) virtual.
     * */
    public void transformarProyeccion2(Matriz3d m, PortaldeVision portal){
        float nx,ny,nz;
        for(int i=0; i<puntos.length; i++){
            nx = m.e[0][0] * puntos[i].puntoProyectado.x + m.e[0][1] * puntos[i].puntoProyectado.y + m.e[0][2] * puntos[i].puntoProyectado.z + m.e[0][3];
            ny = m.e[1][0] * puntos[i].puntoProyectado.x + m.e[1][1] * puntos[i].puntoProyectado.y + m.e[1][2] * puntos[i].puntoProyectado.z + m.e[1][3];
            nz = m.e[2][0] * puntos[i].puntoProyectado.x + m.e[2][1] * puntos[i].puntoProyectado.y + m.e[2][2] * puntos[i].puntoProyectado.z + m.e[2][3];
            puntos[i].puntoProyectado.x = nx;
            puntos[i].puntoProyectado.y = ny;
            puntos[i].puntoProyectado.z = nz;
        }
    }
    
    //	Transformar todos los vrtices mediante una matriz
    //para ser modificados en su universo virtual
    public void transformar(Matriz3d m){
        float nx, ny, nz;
        for(int i=0; i<puntos.length; i++){
            nx = m.e[0][0] * puntos[i].puntoReal.x + m.e[0][1] * puntos[i].puntoReal.y + m.e[0][2] * puntos[i].puntoReal.z + m.e[0][3];
            ny = m.e[1][0] * puntos[i].puntoReal.x + m.e[1][1] * puntos[i].puntoReal.y + m.e[1][2] * puntos[i].puntoReal.z + m.e[1][3];
            nz = m.e[2][0] * puntos[i].puntoReal.x + m.e[2][1] * puntos[i].puntoReal.y + m.e[2][2] * puntos[i].puntoReal.z + m.e[2][3];
            puntos[i].puntoReal.x = nx;
            puntos[i].puntoReal.y = ny;
            puntos[i].puntoReal.z = nz;
        }
    }
    
}

class VerticeSimple {
    Punto3d puntoReal, puntoProyectado;
    public VerticeSimple(){
        puntoProyectado = new Punto3d(0f,0f,0f);
    }
}
class AristaSimple {
    VerticeSimple punto1, punto2;
    java.awt.Color color;
}
