// /c09/bezier/bezier3.c
#include "bezier3_.h"
#include <stdlib.h>

void BEZIER_imprimir3(listaDeListaBezier *ll, FILE *f){
    listaDeListaBezier *temp = NULL;
    int i,j;
    if(ll == NULL)
        return;
    fprintf(f,"\nLista de listas de segmentos de Bzier:\n");
    fprintf(f,"-----\n");
    for(temp=ll; temp; temp = temp->sig){
        BEZIER_imprimir2(&(temp->listaB), f);
        fprintf(f,"-----\n");
    }
}

void BEZIER_configurarListadeListas(listaDeListaBezier *ll, int valorInicial){
    ll->sig=NULL;
    BEZIER_crearLista(&(ll->listaB),1,valorInicial);
}


int BEZIER_agregarListaaLista(listaDeListaBezier *ll, int valorInicial){
    listaDeListaBezier *temp2 = NULL;
    if(!(temp2 = (listaDeListaBezier*)malloc(sizeof(listaDeListaBezier))))
        return BEZIER_COD_ERROR_MEMORIA;
    BEZIER_crearLista(&(temp2->listaB), 1,valorInicial);
    
    //ponerla al final, por defecto
    for(; ll->sig; ll=ll->sig);
    ll->sig = temp2;
    
    return BEZIER_COD_EXITO;
}

