// /c09/bezier/bezier3_.h
#include "bezier2_.h"
/*
 * Este mdulo tiene como propsito implementar
 * una lista de listas de segmentos de Bzier,
 * para tener varias secuencias de segmentos
 * en la misma aplicacin.
 * */

/*
 * Lista de listas de segmentos de Bzier. :S
 * Es una lista lineal simple sin nodo de control.
 * */
typedef struct listaDeListaBezier{
    listaBezier listaB;
    struct listaDeListaBezier *sig;
    
} listaDeListaBezier;

/*
    Imprime en la salida especificada los valores
    almacenados en la estructura, secuencialmente.
*/
void BEZIER_imprimir3(listaDeListaBezier *lista, FILE *f);

/* Configura una ListaDeListaBezier
 * para que est vaca y con las
 * inicializaciones correctas.
 * Por defecto tendr un slo punto que se inicializar
 * en (0.0,0.0,0.0)
 * */
void BEZIER_configurarListadeListas(listaDeListaBezier *ll, int valorInicial);

/* Agrega una nueva lista de segmentos de Bzier
 * y retorna su direccin en '*lista'.
 * */
int BEZIER_agregarListaaLista(listaDeListaBezier *ll, int valorInicial);
