// /c12/julia-mandelbrot/complejo.c
#include "complejo.h"

float CX_modulo(complejo cx){
    return sqrt(cx.r*cx.r + cx.i*cx.i);
}

complejo* CX_suma(complejo *c1, complejo *c2){
    c1->r += c2->r;
    c1->i += c2->i;
    
    return c1;
}

complejo* CX_producto(complejo *c1, complejo *c2){
    float r,i;
    r = c1->r * c2->r - c1->i * c2->i;
    i = c1->r * c2->i + c1->i * c2->r;
    
    c1->r = r;
    c1->i = i;
    return c1;
}

complejo* CX_cuadrado(complejo *c){
    float r,i;
    r = c->r * c->r - c->i * c->i;
    i = (c->r * c->i)*2.0;
    
    c->r = r;
    c->i = i;
    return c;
}
