// /c12/julia-mandelbrot/escala.c
#include "escala.h"

int tR_Vx(escala *s, float xV){
    return (int)(
        s->anchoReal*((xV - s->XminV)/(s->XmaxV - s->XminV))
    );
}

int tR_Vy(escala *s, float yV){
    return (int)(
        s->altoReal*((yV - s->YmaxV)/(s->YminV - s->YmaxV))
    );
}

float tV_Rx(escala *s, int xR){
    return xR*(s->XmaxV - s->XminV)/s->anchoReal + s->XminV;
}

float tV_Ry(escala *s, int yR){
    return yR*(s->YminV - s->YmaxV)/s->altoReal + s->YmaxV;
}

void corregirDireccion(escala *s){
    float temp;
    
    if(s->XmaxV < s->XminV){
        temp = s->XminV;
        s->XminV = s->XmaxV;
        s->XmaxV = temp;
    }
    
    if(s->YmaxV < s->YminV){
        temp = s->YminV;
        s->YminV = s->YmaxV;
        s->YmaxV = temp;
    }
}
