/* cA/Controlador.java
 * Objeto controlador
*/
import java.awt.Graphics;
import java.awt.event.*;

/*
 * Controlador de la aplicacin
 */
public class Controlador {
    
    /**
     * Funcin principal independiente de instancias.
     */
    public static void main(String args[]) {
        new Controlador(args);
    }
    
    Ventana vista;
    Modelo modelo;
    
    /**
        Hilo principal
    */
    public Controlador (String args[]){
        vista = new Ventana(this);
        modelo = new Universo3D();
        
        //mostrar la ventana
        vista.setVisible(true);
        System.out.println("Iniciando aplicacin");
        
        //accin principal o 
        //conjunto de acciones principales
        modelo.hacerAlgo();
        
        //cuando ya acabamos de hacer algo importante,
        //terminamos la aplicacin
        System.exit(0);
    }
    
    /**
     * Simple delegacin del proceso
     * */
    public void dibujar(Graphics g){
        modelo.dibujar(g);
    }
    
    /**
     * Implementar los eventos generados desde la vista.
     * Como el de cerrar la ventana:
     * */
    public WindowAdapter AdaptadorVentana = new WindowAdapter() {
        public void windowClosing(java.awt.event.WindowEvent evt) {
            System.out.println();
            System.exit(0);
        }
    };
}
//fin de la clase Controlador
