/* cA/Ventana.java
 * Objeto vista,
 * tpicamente la Ventana de la aplicacin
*/
import java.awt.*;

public class Ventana extends javax.swing.JFrame implements Config3D{
    
    /**
     * Referencia al controlador para
     * delegarle la respuesta a los 
     * eventos generados desde aqu.
     * */
    private Controlador control;
    
    /**
     * Objeto especial para lograr
     * la delegacin de las solicitudes
     * de refrescamiento
     * */
    private PanelEspecial panelprin;
    
    
    public Ventana(Controlador control) {
        this.control = control;
        inicializarComponentes();
    }

    /** Inicializar los componentes de la interfaz
     * grfica de usuario si es que hay.
     * En el caso de Java con Swing siempre hay.
     * */
    private void inicializarComponentes() {
        
        panelprin = new PanelEspecial(control);
        
        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Ttulo de la aplicacin");
        
        /**
         * Agregar todos los "escuchadores",
         * que deberan estar implementados
         * en el controlador.
         * 
         * Todas las respuestas a los eventos
         * diparados desde este objeto grfico
         * y sus includos, deberan ser respondidos
         * por el controlador con asistencia de
         * los datos del modelo.
         * */
        addWindowListener(control.AdaptadorVentana);
        
        panelprin.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        panelprin.setMinimumSize(new java.awt.Dimension(400, 300));
        
        //agregar el panel principal a la ventana
        getContentPane().add(panelprin, java.awt.BorderLayout.CENTER);
        
        //acomodar dinmicamente los objetos grficos
        pack();
        
        //centrar esta ventana en la pantalla:
        Dimension tamanjoForzado = new Dimension(400, 300);
        java.awt.Dimension tamanjoPantalla = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setLocation((tamanjoPantalla.width-tamanjoForzado.width)/2,(tamanjoPantalla.height-tamanjoForzado.height)/2);
    }
}
//fin de la clase vista
