package proyectoGPC;
/*
Esta clase es un intento de no delegarle dibujo a Graphics (de java.awt)
Es bastante rudimentaria, pero cubre las espectativas...
*/
import java.awt.*;
import java.awt.image.*;

public class GraficoVirtual{
/*	datos que despus sern graficados...
	es la misma idea que la memoria de video en 'c'.
	Claro, que como no es direcctamente al monitor,
	es mucho ms lenta.
*/
	private int[] arreglo;	//'memoria'
	int ancho, alto;
	int color = Color.black.getRGB();

	/**
	* Construcor... inicializa el arreglo y las dimensiones
	*/
	public GraficoVirtual(int ancho, int alto){
		arreglo = new int[ancho * alto];
		this.ancho = ancho;
		this.alto = alto;
	}
	/**
	* Construcor... inicializa el arreglo y las dimensiones
	*/
	public GraficoVirtual(Dimension d){
		arreglo = new int[d.width * d.height];
		this.ancho = d.width;
		this.alto = d.height;
	}
	/*Constructor restringido al paquete... no lo llegamos a usar*/
	GraficoVirtual(int[] arreglo, int ancho, int alto){
		this.arreglo = arreglo;
		this.ancho = ancho;
		this.alto = alto;
	}

	public void ponerColor(Color color){
		this.color = color.getRGB();
	}
	public Color obtenerColor(){
		return new Color(color);
	}

	// deja la 'memoria' lista para dibujar
	public void rellenar(){
		for(int i = 0; i<ancho*alto; i++)
			arreglo[i] = color;
	}
	public void ponerPunto(int x, int y){
		// si no pertenece a la regin, no hacer nada
		if(x>=0 && x<ancho && y>=0 && y<alto)
			arreglo[x+y*ancho] = this.color;
	}
	public void ponerPunto(int x, int y, int color){
		if(x>=0 && x<ancho && y>=0 && y<alto)
			arreglo[x+y*ancho] = color;
	}
	/**
	* Algoritmo de linea de Bresenham
	*/
	public void bres_line(int x1, int y1, int x2, int y2){
		int i,
		sx, sy,  /* paso positivo o negativo (1  -1) */
		dx, dy,  /* delta (diferencia en X y Y entre los puntos lmites) */
		e,
		tmpswap;
		boolean steep = true;

		dx = Math.abs(x2 - x1);
		sx = ((x2 - x1) > 0) ? 1 : -1;
		dy = Math.abs(y2 - y1);
		sy = ((y2 - y1) > 0) ? 1 : -1;
		if (dy > dx) {
		   steep = false;
		   tmpswap = x1;
		   x1 = y1;
		   y1 = tmpswap;

		   tmpswap = dx;
		   dx = dy;
		   dy = tmpswap;

		   tmpswap = sx;
		   sx = sy;
		   sy = tmpswap;
		}
		e = (dy << 1) - dx;
		for(i = 0; i < dx; i++) {
		   if (steep) {
			   ponerPunto(x1,y1);
		   } else {
			   ponerPunto(y1,x1);
		   }
		   while (e >= 0) {
			   y1 += sy;
			   e -= (dx << 1);
		   }
		   x1 += sx;
		   e += (dy << 1);
		}
	}//	fin de bres_line

	//linea horizontal simple
	public void lineah(int x1, int x2, int y){
		int xa, xb, i;
		if(x1>x2){
			xa = x2; xb = x1;
		}else{
			xa = x1; xb = x2;
		}
		for(i=xa; i<=xb; i++)
			ponerPunto(i, y);
	}

	//	dibuja un polgono que se le manda como parmetro
	public void poligono(Polygon poli){
		for(int i=0; i<poli.npoints-1; i++)
			bres_line(poli.xpoints[i],poli.ypoints[i],
				poli.xpoints[i+1],poli.ypoints[i+1]);
		bres_line(poli.xpoints[poli.npoints-1],poli.ypoints[poli.npoints-1],
			poli.xpoints[0],poli.ypoints[0]);
	}

	//	asumiendo un polgono simple, lo dibuja relleno
	//	no nos funcion... :(
	public void poligonoRelleno(Polygon p){
		Rectangle contorno = p.getBounds();
		listaPuntos lista = new listaPuntos(p.xpoints, p.ypoints, p.npoints);
		for(int y=contorno.y; y<(contorno.height-contorno.y); y++){
			lista.seleccionarLineas(y);
			if(lista.a!=null && lista.b!=null){
				lineah(lista.a.x_interseccion(y), lista.b.x_interseccion(y), y);
			}
		}
	}

	public Dimension tamano(){
		return new Dimension(ancho, alto);
	}
	public int[] pixeles(){
		return arreglo;
	}

	//	mtodo que construye una imgen a partir de la 'memoria'
	public Image generarImagen(){
		return Toolkit.getDefaultToolkit().createImage(new MemoryImageSource(
			ancho, alto, /*new DirectColorModel(32, 0x00FF0000, 0x0000FF00, 0x000000FF, 0x7F000000),*/
			pixeles(), 0, ancho
		));
	}

/*
Todo lo que sigue, fue un intento por rellenar polgonos manualmente...
no tuvimos tiempo de corregirlo... tiene un efecto extrao...
*/
	private class linea{
		int x1, y1, x2, y2;
		int x_interseccion(int y){
			return (int)(x1+(y-y1)*(float)(x2-x1)/(y2-y1));
		}
	}
	private class listaPuntos{
		linea[] lineas;	//segmentos de rectas que conforman el polgono
		linea a, b;	//auxiliares para dibujar ms rpido
		int nPuntos=0;
		// se asume que no vienen repetidos el primero y el ltimo
		listaPuntos(int x[], int y[], int tam){
			int i;
			lineas = new linea[tam];
			for(i=0; i<tam; i++){
				lineas[i] = new linea();
				lineas[i].x1 = x[i];
				lineas[i].y1 = y[i];
			}
			for(i=1; i<tam; i++){
				lineas[i-1].x2 = x[i];
				lineas[i-1].y2 = y[i];
			}
			lineas[tam-1].x2 = x[0];
			lineas[tam-1].y2 = y[0];
			nPuntos = tam;
		}
		// se seleccionan los puntos que contiene el valor de y dado (ejey)
		void seleccionarLineas(int ejey){
			a=b=null;
			for(int i=0; i<nPuntos && (a==null || b==null); i++){
				if(lineas[i].y1>=ejey && lineas[i].y2<=ejey)
					a = lineas[i];
				else
				if(lineas[i].y1<=ejey && lineas[i].y2>=ejey)
					b = lineas[i];
			}
		}
	}//	fin de clase interna
}//	fin de GraficoVirtual
