package proyectoGPC;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
/**
 * Un componente que puede ponerse en un contenedor...
 * y mostrar las figuras de la base de datos en Objetos3D
 *
 * @author (Eduardo)
 * @version (a version number or a date)
 */
public class Panel3D extends JPanel implements Config3D{

	//	configuracin del grupo de objetos:
	private Matriz3d matriz = new Matriz3d();
	private int modo_presentacion;
	private int modo_dibujo;
	private boolean dibujar_ejes;

	private Visor afuera;
	private ObjetoEnmallado objeto;
	private Point centro;
	private Punto3d luz;
	private int indice = 0;

    private float Theta, Phi, Omega = 0f;
    Punto3d
        ex = new Punto3d(200f,  0f,  0f),
        ey = new Punto3d(  0f,200f,  0f),
        ez = new Punto3d(  0f,  0f,200f);
    Point
        ejeX = null,
        ejeY = null,
        ejeZ = null;

//	para poder rotar con el mouse:
    private final int numPixelesporGrado = 2;
    private int x=0, y=0;

//	eliminacin del parpadeo
    private Image imgAni;
    private Graphics gAni;
    private Dimension dimThis, dimAni;
    private GraficoVirtual gv;

//	constructores
	public Panel3D(){
		objeto = null;
		afuera = null;
		indice=-1;
        dimThis = this.getSize();
	}
    public Panel3D(ObjetoEnmallado obj, int Theta, int Phi, Visor afuera){
		this.afuera = afuera;
        this.objeto = obj;
        this.indice = 0;
        this.Theta = Theta;
        this.Phi = Phi;
        this.Omega = 0f;
       	matriz.colocarPuntodeVision(Theta, Phi, Omega, 2*objeto.magMasDistante);
		this.configurarObjeto();
        this.modo_presentacion = COLORED_FACES_WIREFRAME;
        this.modo_dibujo = AUTOMATIC;
        matriz.modo_proyeccion = PERSPECTIVE;
        this.dibujar_ejes = true;
        dimThis = this.getSize();
	}

/*	mtodos de configuracin general (para
	usarse desde fuera de esta clase, desde
	el Visor especficamente.
*/
	public void cambiarTheta(float Theta){
		this.Theta = Theta;
       	matriz.colocarPuntodeVision(Theta, Phi, Omega);
		configurarObjeto();
		repaint();
	}
	public void cambiarPhi(float Phi){
		this.Phi = Phi;
       	matriz.colocarPuntodeVision(Theta, Phi, Omega);
		configurarObjeto();
		repaint();
	}
	public void cambiarOmega(float Omega){
		this.Omega = Omega;
       	matriz.colocarPuntodeVision(Theta, Phi, Omega);
		configurarObjeto();
		repaint();
	}
	//	distancia por defecto del objeto
	public void cambiarDistancia(){
       	matriz.colocarPuntodeVision(Theta, Phi, Omega, 2*objeto.magMasDistante);
       	configurarObjeto();
	}
	public void cambiarDistancia(float distancia){
		if(distancia>0)
			matriz.colocarPuntodeVision(Theta, Phi, Omega, distancia);
		else
			throw new IllegalArgumentException("No se permiten distancias negativas");
       	configurarObjeto();
	}
	public void seleccionarModoPresentacion(int modo){
		if((MODO_PRESENTACION & modo) == MODO_PRESENTACION)
			modo_presentacion = modo;
		else
			throw new IllegalArgumentException("Valor no permitido");
		repaint();
//	talvez, con esto, se pueda redibujar instantaneamente...
//    public static void paintComponent(Graphics g, Component c, Container p, int x, int y, int w, int h) {
//    SwingUtilities.paintComponent(gAni, this, (Container) afuera, 0, 0, dimAni.width, dimAni.height);
	}
	public void seleccionarModoProyeccion(int modo){
		if((MODO_PROYECCION & modo) == MODO_PROYECCION)
			matriz.modo_proyeccion = modo;
		else
			throw new IllegalArgumentException("Valor no permitido");
       	configurarObjeto();
		repaint();
	}
	public void seleccionarModoDibujo(int modo){
		if((MODO_DIBUJO & modo) == MODO_DIBUJO)
			modo_dibujo = modo;
		else
			throw new IllegalArgumentException("Valor no permitido");
		repaint();
	}
	public void dibujarEjes(boolean modo){
		dibujar_ejes = modo;
		repaint();
	}
	public void cambiarVisor(Visor afuera){
		this.afuera = afuera;
	}
	private void configurarObjeto(){
        objeto.transformar(matriz);
        ejeX = matriz.transformar2D(ex);
        ejeY = matriz.transformar2D(ey);
        ejeZ = matriz.transformar2D(ez);

		matriz.calcularInversa();
		if(matriz.tiene_inversa && centro != null)
			luz = matriz.inv.transformar(new Punto3d(0f, centro.y, matriz.distancia));
    }
/*
* Mtodos para que el exterior interacte con esta clase
*/
    public void figuraAnterior(){
		indice--;
		if(indice<0)
			indice = Objetos3D.figuras.length-1;
		objeto = Objetos3D.figuras[indice];
       	matriz.distancia = 2*objeto.magMasDistante;
		repaint();
	}
	public void figuraSiguiente(){
		indice++;
		if(indice >= Objetos3D.figuras.length)
			indice = 0;
		objeto = Objetos3D.figuras[indice];
       	matriz.distancia = 2*objeto.magMasDistante;
		repaint();
	}
	public int Indice(){
		return indice;
	}
	public float Distancia(){
		return matriz.distancia;
	}
	public float DistanciaMax(){
		return objeto.magMasDistante;
	}
    public void actualizar(){
		repaint();
	}

//	Mtodos relacionados con la graficacin
    /*public void paint(Graphics g){
        update(g);
    }*/
    //public void update(Graphics g){
    public void paintComponent(Graphics g){
        if(objeto!=null){
			if ((gAni==null) || (gv==null) || (dimThis.width!=dimAni.width) || (dimThis.height!=dimAni.height)) {
				// si el tamao ha cambiado o es primera vez que se dibuja

				dimAni = dimThis = this.getSize();
				// se llama al mtodo createImage de la clase Component
				imgAni = createImage(dimAni.width, dimAni.height);
				// se llama al mtodo getGraphics de la clase Image
				gAni = imgAni.getGraphics();
				// se construyen los objetos de dibujo
				gv = new GraficoVirtual(dimAni);
				// centro del panel de dibujo
				centro = new Point((int)(dimAni.getWidth()/2), (int)(dimAni.getHeight()/2));
				configurarObjeto();
			}
			// se establecen las propiedades del contexto grfico invisible,
			// y se dibuja sobre l, dependiendo del modo de dibujo...
			// ver mtodos rellenar, ponerColor, linea
	//*****************************
			ponerColor(getBackground());
			rellenar();
			ponerColor(Color.black);

	        objeto.aristas.permitirDibujar();

		//	elegir forma de presentar:
			switch(modo_presentacion){
			    case SYMPLE_WIREFRAME:
		            dibujarSW();
			    break;
			    case HIDE_FACES_VECTORIAL_WIREFRAME:
				    dibujarHFVW();
			    break;
			    case COLORED_FACES_WIREFRAME:
				    dibujarCFW();
			    break;
    //	no lo logramos
    //			case HIDE_FACES_ZBUFFER_WIREFRAME:
    //				dibujarHFZW();
    //			break;
			    case FLAT_SHADING:
				    dibujarFS();
			    break;
			}

			if(dibujar_ejes){
				ponerColor(Color.red);   // dibujar eje x
				linea(centro.x, centro.y,
					centro.x + ejeX.x, centro.y + ejeX.y);

				ponerColor(Color.green); // dibujar eje y
				linea(centro.x, centro.y,
					centro.x + ejeY.x, centro.y + ejeY.y);

				ponerColor(Color.blue);  // dibujar eje z
				linea(centro.x, centro.y,
					centro.x + ejeZ.x, centro.y + ejeZ.y);
		  	}

	//.............................
			// finalmente se hace visible la imagen invisible a partir del punto (0, 0)
			// utilizando el propio panel como ImageObserver
			// depende del modo de dibujo... AUTOMATIC o MANUAL
			g.drawImage(
				((modo_dibujo & MANUAL)==MANUAL)?
				gv.generarImagen():imgAni,
			0,0,this);
		} else{
			g.setColor(Color.red);
			g.drawString("Figura no cargada",50,50);
		}
    }   //fin de update

    private void dibujarSW(){	//SYMPLE_WIREFRAME
		int h, k;
        nodoPoligono np;
        nodoArista na;
        for(h=0, np = objeto.poligonos.primero;
        		h<objeto.poligonos.numPoligonos;
        		h++, np = np.siguiente)
			for(k=0, na = np.aristas.primera;
					k<np.aristas.numAristas;
					k++, na = na.siguiente)
/*simplemente se itera a travs de cada arista de cada polgono*/
				if(!na.arista.dibujada){
					linea(centro.x + (int)na.arista.v1.xp, centro.y + (int)na.arista.v1.yp,
						centro.x + (int)na.arista.v2.xp, centro.y + (int)na.arista.v2.yp);
					na.arista.dibujada = true;
				}//	fin de if(!na...) y de los dos for()
    }//	fin de dibujarSW

	private void dibujarHFVW(){	//HIDE_FACES_VECTORIAL_WIREFRAME
		int h, k;
        nodoPoligono np;
        nodoArista na;
        Vertice vert;
//        boolean todos = true;
        Punto3d hacia_pObservacion,	//desde el polgono hacia el centro del plano de observacin
        	viewport;	//desde el origen hacia el centro del plano de observacin
        viewport = matriz.vision;
        for(h=0, np = objeto.poligonos.primero;
        		h<objeto.poligonos.numPoligonos;
        		h++, np = np.siguiente){
			vert=np.aristas.VerticeMasCercano();
			if((matriz.modo_proyeccion & PERSPECTIVE)==PERSPECTIVE)
				hacia_pObservacion = viewport.resta(vert.punto_3d());
			else
				hacia_pObservacion = viewport;

			/*menor que cero porque los polgonos estn orientados en sentido horario,
			y por lo tanto, el vector normal est hacia adentro*/
			if(np.Normal().punto(hacia_pObservacion)<0f)
			for(k=0, na=np.aristas.primera; k<np.aristas.numAristas; k++, na=na.siguiente)
			if(!na.arista.dibujada){
				linea(centro.x + (int)na.arista.v1.xp, centro.y + (int)na.arista.v1.yp,
					centro.x + (int)na.arista.v2.xp, centro.y + (int)na.arista.v2.yp);
				na.arista.dibujada = true;
			}	//fin de if(!na...), for(k=0...) y if(np.Normal()...)
		}//	fin de for(h=0...)
	}//	dibujarHFVW

	private void dibujarCFW(){	//COLORED_FACES_WIREFRAME
		Polygon poli;
		int[] xpuntos, ypuntos;
		Color col, colAnt = gv.obtenerColor();
		int h, k, numA;
        nodoPoligono np;
        nodoArista na;
        Vertice vert;
        Punto3d hacia_pObservacion,	//desde el polgono hacia el centro del plano de observacin
        	viewport;	//desde el origen hacia el centro del plano de observacin
        viewport = matriz.vision;
//	ordenar la lista de polgonos, de ms lejano a ms cercano
		objeto.poligonos.ordenarPoligonos();
        for(h=0, np = objeto.poligonos.primero;
        		h<objeto.poligonos.numPoligonos;
        		h++, np = np.siguiente){
			vert=np.aristas.VerticeMasCercano();
			numA = np.aristas.numAristas;
			xpuntos = new int[numA];ypuntos = new int[numA];
			if((matriz.modo_proyeccion & PERSPECTIVE)==PERSPECTIVE)
				hacia_pObservacion = viewport.resta(vert.punto_3d());
			else
				hacia_pObservacion = viewport;

			/*menor que cero porque los polgonos estn orientados en sentido horario,
			y por lo tanto, el vector normal est hacia adentro*/
			if(np.Normal().punto(hacia_pObservacion)<0f)
				col = COL_AFUERA;
			else
				col = COL_ADENTRO;
			na=np.aristas.primera;
			for(k=0; k<numA; k++, na=na.siguiente){
				xpuntos[k] = centro.x + (int)na.cabeza().xp;
				ypuntos[k] = centro.y + (int)na.cabeza().yp;
			}
			poli = new Polygon(xpuntos, ypuntos, numA);
			ponerColor(col);
			poligonoRelleno(poli);
		}//	fin de for(h=0...)
		ponerColor(colAnt);
	}//	dibujarCFW

//	no nos alcanz el tiempo para el z-buffer
	private void dibujarHFZW(){	//HIDE_FACES_ZBUFFER_WIREFRAME

	}
	private void dibujarFS(){	//FLAT_SHADING
		Polygon poli;
		int[] xpuntos, ypuntos;
		Color col, colAnt = gv.obtenerColor();
		int h, k, numA;
		float prod;
        nodoPoligono np;
        nodoArista na;
        Vertice vert;
        Punto3d hacia_pObservacion,	//desde el polgono hacia el centro del plano de observacin
        	viewport;	//desde el origen hacia el centro del plano de observacin
        viewport = matriz.vision;
//	ordenar la lista de polgonos, de ms lejano a ms cercano
		objeto.poligonos.ordenarPoligonos();
        for(h=0, np = objeto.poligonos.primero;
        		h<objeto.poligonos.numPoligonos;
        		h++, np = np.siguiente){
			vert=np.aristas.VerticeMasCercano();
			numA = np.aristas.numAristas;
			xpuntos = new int[numA];ypuntos = new int[numA];
			if((matriz.modo_proyeccion & PERSPECTIVE)==PERSPECTIVE)
				hacia_pObservacion = viewport.resta(vert.punto_3d());
			else
				hacia_pObservacion = viewport;

			prod = np.Normal().punto(luz)/np.Normal().magnitud()/luz.magnitud();
			// prod debe ser unitario;
			col = reflejo(prod);
			na=np.aristas.primera;
			for(k=0; k<numA; k++, na=na.siguiente){
				xpuntos[k] = centro.x + (int)na.cabeza().xp;
				ypuntos[k] = centro.y + (int)na.cabeza().yp;
			}
			poli = new Polygon(xpuntos, ypuntos, numA);
			ponerColor(col);
			poligonoRelleno(poli);
		}//	fin de for(h=0...)
		ponerColor(colAnt);
	}//	dibujarFS

//	terminan los mtodos de dibujo
//++++++++++++++++++++++++++++++++++++++

//	devuelve el color en escala de grices que representa el brillo
	private Color reflejo(float m){
		int temp = (int)(250*Math.abs(m));
		return new Color(temp, temp, temp);
	}


	public boolean imageUpdate(Image img, int infoflags,
	int x, int y, int width, int height){
		/*evitar que siga redibujandose automticamente
		cuando est en modo manual*/
		return ((modo_dibujo & MANUAL)==MANUAL)?
				true:super.imageUpdate(img, infoflags,x,y, width, height);
	}

/*
	mtodos que delegan el dibujado a Graphics o a GraficoVirtual
*/

//	intentar decidir cmo dibujar un polgono
	private void poligono(Polygon poli){
	switch(modo_dibujo){
		case AUTOMATIC:
			gAni.drawPolygon(poli);
			gv.poligono(poli);
		break;
		case MANUAL:
			gv.poligono(poli);
		break;
		default:
			System.out.println("valor no soportado en poligono");
	}
	}

//	intentar decidir cmo rellenar un polgono
	private void poligonoRelleno(Polygon poli){
	switch(modo_dibujo){
		case AUTOMATIC:
			gAni.fillPolygon(poli);
			gv.poligonoRelleno(poli);
		break;
		case MANUAL:
			gv.poligonoRelleno(poli);
		break;
		default:
			System.out.println("valor no soportado en poligonoRelleno");
	}
	}

/*Rellena con el color definido por ponerColor*/
	private void rellenar(){
	switch(modo_dibujo){
		case AUTOMATIC:
			gAni.fillRect(0,0,dimAni.width, dimAni.height);
			gv.rellenar();
		break;
		case MANUAL:
			gv.rellenar();
		break;
		default:
			System.out.println("valor no soportado en rellenar");
	}
	}
	private void ponerColor(Color color){
	switch(modo_dibujo){
		case AUTOMATIC:
			gAni.setColor(color);
			gv.ponerColor(color);
		break;
		case MANUAL:
			gv.ponerColor(color);
		break;
		default:
			System.out.println("valor no soportado en ponerColor");
	}
	}
	private void punto(int x, int y){
		if(x>=0 && x<dimAni.width && y>=0 && y<dimThis.height)
		switch(modo_dibujo){
			case AUTOMATIC:
				gAni.drawLine(x, y, x, y);
				gv.ponerPunto(x, y);
			break;
			case MANUAL:
				gv.ponerPunto(x, y);
			break;
			default:
				System.out.println("valor no soportado en punto");
		}
	}
	private void linea(int x1, int y1, int x2, int y2){
	switch(modo_dibujo){
		case AUTOMATIC:
			gAni.drawLine(x1, y1, x2, y2);
			gv.bres_line(x1, y1, x2, y2);
		break;
		case MANUAL:
			gv.bres_line(x1, y1, x2, y2);
		break;
		default:
			System.out.println("valor no soportado en punto");
	}
	}




//	auxiliares para poder rotar con el mouse....
	public MouseAdapter AdaptadorMouse = new MouseAdapter(){
		public void mousePressed(MouseEvent e){
			x = e.getX(); y = e.getY();
		}
		public void mouseClicked(MouseEvent e){
			if(e.getClickCount() == 2)
				matriz.colocarPuntodeVision(Theta, Phi, Omega, 2*objeto.magMasDistante);
				afuera.cambioInternoDistancia(2*objeto.magMasDistante);
		}
	};//	fin del objeto MouseAdapter

	public MouseMotionAdapter AdaptadorMouseMotion = new MouseMotionAdapter(){
		public void mouseDragged(MouseEvent e){
/*	estas variables pueden ser miembros privados,
	para evitar crearlas y destruirlas a cada
	intervalo del mouse
*/
			boolean cambio = false;
			int xn = e.getX(), yn = e.getY();

			if(Math.abs(xn-x)>=numPixelesporGrado){
				Theta -= xn-x;
				if(Theta < 0)
					Theta = 359;
				else if(Theta > 359)
					Theta = 0;

				x = xn;
				afuera.cambioInternoTheta(Theta);
				cambio = true;
			}
			if(Math.abs(yn-y)>=numPixelesporGrado){
				Phi -= yn-y;
				if(Phi < 0)
					Phi = 359;
				else if(Phi > 359)
					Phi = 0;

				y = yn;
				afuera.cambioInternoPhi(Phi);
				cambio = true;
			}
			if(cambio){
				matriz.colocarPuntodeVision(Theta, Phi, Omega);
				configurarObjeto();
				repaint();
			}
		}
	};//	fin del objeto MouseMotionAdapter
	public ComponentAdapter AdaptadorComponent = new ComponentAdapter(){
		public void componentResized(ComponentEvent e){
			dimThis = e.getComponent().getSize();
		}
	};

}//fin de la clase Panel3D

